package com.zipcodewilmington.phonebook;


import com.sun.tools.classfile.Instruction;

import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

/**
 * Created by jaejoson on 10/28/18
 */
public class PhoneBook {
    private String name;
    private String phoneNumber;

    public void PhoneBook (String name, String phoneNumber) {
        this.name = name;
        this.phoneNumber = phoneNumber;
    }

    public static void main(String[] args) {
        PhoneBook phoneBook = new PhoneBook();
        phoneBook.displayMenu();

    }

    public void displayMenu() {
        Scanner input = new Scanner(System.in);
        System.out.println("PhoneBook options: ");
        System.out.println("1. Check if entry is already there");
        System.out.println("2. Add an entry");
        System.out.println("3. Get someone's phone number");
        System.out.println("4. Remove an entry");
        System.out.println("5. Reverse phone look-up - returns a name");
        System.out.println("6. Get a list of all entries");
        int choice = input.nextInt();
        input.nextLine();

        switch (choice) {
            case 1:
                hasEntry(name);
                break;
            case 2:
                addEntry(name, phoneNumber);
                break;
            case 3:
                lookupNumber(name);
                break;
            case 4:
                removeEntry(name);
                break;
            case 5:
                reversePhoneNumber(phoneNumber);
                break;
            case 6:
                listAll();
                break;

        }
    }


    public boolean hasEntry(String name) {
        System.out.println("Which name do you want to check the number for?");
        Scanner input = new Scanner(System.in);
        name = input.nextLine();
        if (phoneBook.containsKey(name)) {
            System.out.print("Does exist");
            return true;
        } else {
            System.out.print("Sorry, not available");
            return false;
        }
    }


    public void addEntry(String name, String phoneNumber) {
        System.out.print("What name would you like to add?");
        Scanner input = new Scanner(System.in);
        name = input.nextLine();
        System.out.println("Enter the number you want to add to " + name);
        phoneNumber = input.nextLine();
        phoneBook.put(name, phoneNumber);
        System.out.print("Number added");

        displayMenu();
    }


    public void lookupNumber(String name) {                     //not sure why this is not working :(
        System.out.print("Whose number are you looking for?");
        Scanner input = new Scanner(System.in);
        name = input.nextLine();
        String number = "";
            if (phoneBook.containsKey(name)) {
                number = phoneBook.get(name);
            }
        System.out.print("Here's the phone number for that person: " + number);
//        displayMenu();

    }


    public void removeEntry(String name) {
        System.out.println("Enter the name you wish to delete: ");
        Scanner input = new Scanner(System.in);
        name = input.nextLine();
        if (phoneBook.containsKey(name)) {
            phoneBook.remove(name);
        }
        displayMenu();
    }


    public void reversePhoneNumber(String phoneNumber) {
        System.out.println("What number do you want to search for?");
        Scanner input = new Scanner(System.in);
        phoneNumber = input.nextLine();
        if (phoneBook.containsValue(phoneNumber)) {
            for (Map.Entry<String, String> entry : phoneBook.entrySet()) {
                name = entry.getKey();
            }
        }
        System.out.print(name);
    }




    public void listAll() {
        String key = name;
        String value = phoneNumber;
        for (Map.Entry<String, String> entry : phoneBook.entrySet()) {
           key = entry.getKey();
           value = entry.getValue();
           System.out.print("Name: " + key + " Phone Number: " + value + "\t");

        }
    }


    TreeMap<String, String> phoneBook = new TreeMap<>();

    {
        phoneBook.put("Bro", "2155622777");
        phoneBook.put("Christina", "4902541890");
        phoneBook.put("Nicole", "3021773456");
    }
}
